#ifndef DEMON_H
#define DEMON_H


#include "Sprite.h"
#include "Path.h"

class Demon
{
    public:
        Demon(int eventId, int spriteIndex, Path& path);
        ~Demon();


        void hit();
        void miss();

        void setPercent(float p);
        void step();
        void draw(sf::RenderWindow& window, int xOffset = 0, int missTimer = 0);

    private:
        float dx;
        float dy;
        float x;
        float y;
        int id;
        Sprite sprite;
    public:
        int lifeTimer;
    private:
        float percent;
        bool wasHit;
        bool wasMiss;
        Path& path;
        unsigned frame;
        float scale;
        float alpha;
};

#endif // DEMON_H
