#ifndef LEVEL_H
#define LEVEL_H

#include "includes.h"

enum EventType
{
    EVENT_TAMB,
    EVENT_KICK,
    NO_EVENT
};

struct Event
{
    unsigned offset;
    EventType type;
};

struct SortEvent
{
    bool operator() (Event i, Event j) { return i.offset < j.offset; }
};

class Level
{
    public:
        Level();
        ~Level();

        void load(string fileName);
        EventType pollEvent(int offset,int keepAlive);

        int getOffsetToEvent(EventType type);
        int popEvent(EventType type);
        void addEvent(int start, int end, string line);

        void drawNextEvents(sf::RenderWindow& window, unsigned offset);

        int getEventIndexAtTime(unsigned offset, int time);

        vector<Event> events;
};

#endif // LEVEL_H
