#include "Path.h"

Path::Path(sf::Vector2f origin, sf::Vector2f target):
    opposite(false),
    origin(origin),
    target(target),
    offset(0)
{
    angle = atan2f(target.y - origin.y, target.x - origin.x);
    mag = sqrtf(powf(target.y-origin.y, 2) + powf(target.x-origin.x, 2));
        cosTheta = cosf(angle);;
        sinTheta = sinf(angle);
}

Path::~Path()
{
    //dtor
}

void Path::step()
{
    offset += 0.007f;
}
// Pass in percent of path, and get position you'd find that point.
sf::Vector2f Path::getPosition(float percent)
{
    sf::Vector2f returnVal = origin;
    float x0 = percent * mag;
    float y0 = sinf((percent+offset) * 3.141592653589793) * 90 * cosf(percent * 3.141592653589793 / 2.f);
    if(opposite)
    {
        y0 = -y0;
    }
    returnVal.x += x0 * cosTheta - y0 * sinTheta;
    returnVal.y += x0 * sinTheta + y0 * cosTheta;

    return returnVal;
}
