#ifndef RESOURCEMANAGER_H
#define RESOURCEMANAGER_H

#include "includes.h"

class ResourceManager
{
    public:
        static map<string, sf::SoundBuffer*> soundBuffers;
        static map<string, sf::Texture*> textures;

        static sf::Shader* shader;
        static sf::Font* font;
        static sf::Music* creditsMusic;

        static bool loadTexture(string filename);
        static sf::Texture* getTexture(string filename);

        static bool loadSoundBuffer(string filename);
        static sf::SoundBuffer* getSoundBuffer(string filename);

        static void cleanUp();
};

#endif // RESOURCEMANAGER_H
