#ifndef SECRET_H
#define SECRET_H

#include "includes.h"

class Secret
{
    public:
        Secret();
        ~Secret();


        void left();
        void right();
        void up();
        void down();


        void reset();
        void gameOver();
        void step();
        void draw(sf::RenderWindow& window);

        struct
        {
            float x;
            float y;
            float dx;
            float dy;
            float angle;
        } player;
        float playerAccel;
        struct Obstacle
        {
            bool active;
            float x;
            float y;
            float dx;
            float dy;
            float angle;
            Obstacle():
                active(false) { angle = 0; }
        };

        bool open;

        vector<Obstacle> obstacles;
        int score;
        int highScore;
        int spawnTimer;
        int difficulty;
        int frame;

        sf::Vector2f origin;
        float targetOrigin;
};

#endif // SECRET_H
