#ifndef SONG_H
#define SONG_H

#include "includes.h"

class Song
{
    public:
        static const int FFT_SAMPLES = 256;
        Song(sf::SoundBuffer* buffer);
        ~Song();

        void play();
        void stop();

        static void fastFourierTransform(ComplexArray& x);

        void skip();

        void update();

        int getAmplitude();
        unsigned getOffset();

        int getBeatMeasureSize(int beatRate);
        int getBeatOffset(int beatRate);
        int beatScore(int beatRate);

        void setVolume(float f);
        void setLoop(bool b);

        bool isFinished();
        ComplexNumber fftSamples[FFT_SAMPLES];
        ComplexArray fftResult;
    private:
        sf::Sound sound;
        const sf::Int16* samples;
        unsigned sampleRate;
        unsigned sampleCount;
        unsigned lastSampleOffset;

        int maxAmplitude;
        int fftSampleIndex;

        float baseVolume;
        float volume;

        bool loop;
};

#endif // SONG_H
