#ifndef TOOLBOX_H_INCLUDED
#define TOOLBOX_H_INCLUDED

#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>
#include <SFML/Network.hpp>
#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <string>
#include <sstream>
#include <random>
#include <vector>
#include <fstream>
#include <cassert>
#include <algorithm>
#include <functional>
#include <cctype>
#include <locale>
#include <complex>
#include <valarray>

const double PI = 3.141592653589793238460;

typedef std::complex<double> ComplexNumber;
typedef std::valarray<ComplexNumber> ComplexArray;

using namespace std;

// trim from start
static inline std::string &ltrim(std::string &s) {
        s.erase(s.begin(), std::find_if(s.begin(), s.end(), std::not1(std::ptr_fun<int, int>(std::isspace))));
        return s;
}

// trim from end
static inline std::string &rtrim(std::string &s) {
        s.erase(std::find_if(s.rbegin(), s.rend(), std::not1(std::ptr_fun<int, int>(std::isspace))).base(), s.end());
        return s;
}

// trim from both ends
static inline std::string &trim(std::string &s) {
        return ltrim(rtrim(s));
}
#endif // TOOLBOX_H_INCLUDED
